#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <OS.h>

//#define ALLOC_MALLOC 1
#define ALLOC_AREA 1

enum {
	allocSize = 128*1024
};

struct List {
	List *next;
	size_t size;
};

List *NewItem(size_t size)
{
	List *it;
#if ALLOC_MALLOC
	it = (List*)malloc(size);
#elif ALLOC_AREA
	area_id area = create_area("item area", (void**)&it, B_ANY_ADDRESS, size, B_NO_LOCK, B_READ_AREA | B_WRITE_AREA);
	if (area < B_OK) it = NULL;
#endif
	if (it == NULL) return NULL;
	memset(it, 0xcc, size); // ensure that physical memory is allocated
	it->next = NULL;
	it->size = size;
	return it;
}

void DeleteItem(List *it)
{
#if ALLOC_MALLOC
	free(it);
#elif ALLOC_AREA
	area_id area = area_for(it);
	delete_area(area);
#endif
}

int main()
{
	List *list = NULL, *it = NULL;
	size_t totalSize = 0;
	for (int i = 0; i < 48; i++) {
		for (;totalSize < 2*1024*1024*1024LL;) {
			it = NewItem(allocSize);
			if (it == NULL) break;
			totalSize += it->size;
			it->next = list; list = it;
		}
		printf("alloc totalSize: %ld", totalSize); /*getc(stdin);*/ printf("\n");
		while (list != NULL) {
			it = list; list = list->next;
			totalSize -= it->size;
			DeleteItem(it);
		}
		printf("free totalSize: %ld", totalSize); /*getc(stdin);*/ printf("\n");
	}
	printf("done"); getc(stdin);
	return 0;
}
